> For the complete documentation index, see [llms.txt](https://docs.wisej.com/api/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/api/wisej.web/content/canvas/wisej.web.canvascompositeoperation.md).

# CanvasCompositeOperation

Namespace: **Wisej.Web**

Assembly: **Wisej.Framework** (4.0.0.0)

Determines how a source (new) image are drawn onto a destination (existing) image.

{% tabs %}
{% tab title="C#" %}

```csharp
public enum CanvasCompositeOperation : Enum
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Enum CanvasCompositeOperation As [Enum]
```

{% endtab %}
{% endtabs %}

## Fields

| Name                | Description                                                                                                                                                                         |
| ------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **Copy**            | Displays the source image. The destination image is ignored.                                                                                                                        |
| **DestinationAtop** | Displays the destination image on top of the source image. The part of the destination image that is outside the source image is not shown.                                         |
| **DestinationIn**   | Displays the destination image in to the source image. Only the part of the destination image that is INSIDE the source image is shown, and the source image is transparent.        |
| **DestinationOut**  | Displays the destination image out of the source image. Only the part of the destination image that is OUTSIDE the source image is shown, and the source image is transparent.      |
| **DestinationOver** | Displays the destination image over the source image.                                                                                                                               |
| **Lighter**         | Displays the source image + the destination image.                                                                                                                                  |
| **SourceAtop**      | Displays the source image on top of the destination image. The part of the source image that is outside the destination image is not shown.                                         |
| **SourceIn**        | Displays the source image in to the destination image. Only the part of the source image that is INSIDE the destination image is shown, and the destination image is transparent.   |
| **SourceOut**       | Displays the source image out of the destination image. Only the part of the source image that is OUTSIDE the destination image is shown, and the destination image is transparent. |
| **SourceOver**      | Default. Displays the source image over the destination image.                                                                                                                      |
| **Xor**             | The source image is combined by using an exclusive OR with the destination image.                                                                                                   |

## Used By

| Name                                                                                         | Description                                                       |
| -------------------------------------------------------------------------------------------- | ----------------------------------------------------------------- |
| [Canvas.GlobalCompositeOperation](/api/wisej.web/content/canvas.md#globalcompositeoperation) | Sets or returns how a new image are drawn onto an existing image. |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.wisej.com/api/wisej.web/content/canvas/wisej.web.canvascompositeoperation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
